Ruby - Bug #12251

DelegateClass(OpenStruct) behavior in 2.3.0 different from 2.2
04/05/2016 07:45 PM - dblock (Daniel Doubrovkine)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 2.3.0p0 (2015-12-25 revision Backport: 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3:
53290) [x86_64-darwin15] UNKNOWN

Description
This came from https://github.com/ruby-grape/grape/issues/1348

require 'delegate'
require 'ostruct'

class AttributeTranslator < DelegateClass (OpenStruct)

def initialize (attributes = {})
ostruct = OpenStruct.new(attributes)
super ostruct
end
end

def namespace
'foobar'
end

instance = AttributeTranslator.new (namespace: '/"'")
puts instance.namespace

Ruby 2.2.1
="/

Ruby 2.3.0
=> 'foobar’

Halp?

Related issues:
Related to Ruby - Bug #12136: OpenStruct.new(format: :bar).send :format # => ... Closed

History

#1 - 04/06/2016 05:13 PM - marcandre (Marc-Andre Lafortune)

- Related to Bug #12136: OpenStruct.new(format: :bar).send :format # => too few arguments added

#2 - 02/27/2020 08:00 AM - matz (Yukihiro Matsumoto)
Hmm, it was caused by OpenStruct performance pull-request. Maybe we should revert the PR?
Matz.

#3 - 02/28/2020 05:27 AM - nobu (Nobuyoshi Nakada)

The pull-request and commit.

#4 - 09/22/2020 08:06 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Open to Closed

The OpenStruct changes were reverted starting around e026e186f4a01aa3f6cd02ae6ef33f44£129361c, so you once again get / output for the
program.

07/16/2025 1/1



https://github.com/ruby-grape/grape/issues/1348
https://github.com/ruby/ruby/pull/1033
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/7fa21558051e5412dcb790f528e392476edd4389
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/e026e186f4a01aa3f6cd02ae6ef33f44f129361c
http://www.tcpdf.org

